package com.android.gps;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.location.Criteria;
import android.location.GpsSatellite;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo.State;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.text.format.DateFormat;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;


public class GpsDemoActivity extends Activity {
    
	private static LocationManager locationManager;
	private Timer timer;
	private TimerTask task;
	private Handler handler;
	private Message msg;
	private boolean fixed;
	private ConnectivityManager conMan;
	private OnClickListener listener;
    private String mFilter;
    private int num = 0;
    private Button startGps;
    
    private TextView myLocationText;
    private TextView Latitude;
	private TextView Longitude;
	private TextView High;
	private TextView Direction;
	private TextView Speed;
	private TextView GpsTime;
	
    private TextView timercount;
    private TextView satellitenumber;
    private TextView allstrength;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.gps);
        startGps = (Button)findViewById(R.id.gps);
        
        myLocationText = (TextView)findViewById(R.id.myLocationText);
        Latitude = (TextView) findViewById(R.id.tvlatitude);
		Longitude = (TextView) findViewById(R.id.tvlongitude);
		High = (TextView) findViewById(R.id.tvhigh);
		Direction = (TextView) findViewById(R.id.tvdirection);
		Speed = (TextView) findViewById(R.id.tvspeed);
		GpsTime = (TextView) findViewById(R.id.tvgpstime);
		
        timercount = (TextView)findViewById(R.id.timercount);
        satellitenumber = (TextView)findViewById(R.id.satellitenum);
        allstrength = (TextView)findViewById(R.id.allstrength);
        conMan = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        
      
        	listener = new OnClickListener() {
        		@Override
        		public void onClick(View v) {
        			switch (v.getId()) {
        			case R.id.gps:
        				//toggleGPS();
        				Intent intent = new Intent(Settings.ACTION_SECURITY_SETTINGS);  
        				startActivityForResult(intent, 0);
        				gpsStatus();
        				break;
        			default:
        				break;
        			}
        		}
        	};
        	startGps.setOnClickListener(listener);
        	handler = new Handler() {
        		@Override
        		public void handleMessage(Message msg) {
        			super.handleMessage(msg);
        			if(msg.what>=0){
        				timercount.setText(String.valueOf(msg.what));
        				if(fixed == true)
        					timer.cancel();
        			}
        		}
        	};
        	
        	locationManager = (LocationManager)this.getSystemService(Context.LOCATION_SERVICE);
        	//gpsStatus(); 
        	Criteria filter = getFilter(); 
        	mFilter = locationManager.getBestProvider(filter, true);
        	locationManager.addGpsStatusListener(gpsStatusListener);
        	locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 1000, 3, locationListener);
       
    }
    
    private Criteria getFilter() {  
        Criteria criteria = new Criteria();  
        criteria.setAccuracy(Criteria.ACCURACY_FINE);  
        criteria.setAltitudeRequired(true);  
        criteria.setBearingRequired(true);
        criteria.setSpeedRequired(true);
        criteria.setCostAllowed(false);  
        criteria.setPowerRequirement(Criteria.POWER_LOW);  
        return criteria;  
    } 
    
    private boolean getconnectstate(){
    	State mobile = conMan.getNetworkInfo(ConnectivityManager.TYPE_MOBILE).getState();
		if(mobile.toString()== "CONNECTED")
			return true;
		else
			return false;
    }
    
    private void gpsStatus() {
        if (locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
            Toast.makeText(this, getString(R.string.gpsopened).toString(), Toast.LENGTH_SHORT).show();
            if(timer == null && task == null){
    			timer = new Timer();
    			task = new TimerTask(){
    				int i = 1;
    				@Override
    				public void run() {
    					if (null == msg) {
    							msg = new Message();
    						} else {
    							msg = Message.obtain();
    						}
    					msg.what = i++;
    					handler.sendMessage(msg);
    					}
    				};
    				timer.schedule(task,0,1000);
    		}
        }else {  
            Toast.makeText(this, getString(R.string.gpsnotopen).toString(), Toast.LENGTH_SHORT).show(); 
            myLocationText.setText(getString(R.string.notfixed).toString());
            Latitude.setText("");
			Longitude.setText("");
			High.setText("");
			Direction.setText("");
			Speed.setText("");
			GpsTime.setText("");
			
            timercount.setText("0");
            satellitenumber.setText("0");
            allstrength.setText("0");
            fixed = false;
            if(timer != null){
            	task.cancel();
            	task = null;
            	timer.cancel();
            	timer.purge();
            	timer = null;
            }
        }  
    } 
    
    @Override  
    protected void onResume() {  
    	if(getconnectstate()){
      }else{
      	//Toast.makeText(this, getString(R.string.disconnect).toString(), Toast.LENGTH_SHORT).show();
      }
    	gpsStatus();
    	locationManager.addGpsStatusListener(gpsStatusListener);
    	locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 1000, 10, locationListener);  
        super.onResume();  
    }
    
    @Override  
    protected void onPause() {  
    	fixed = false;
    	if(timer != null && task != null){
    		task.cancel();
    		task = null;
    		timer.cancel();
    		timer.purge();
    		timer = null;
    	}
    	locationManager.removeGpsStatusListener(gpsStatusListener);
    	locationManager.removeUpdates(locationListener);
        super.onPause();  
    }
    
    @Override  
    protected void onDestroy() {  
        super.onDestroy();  
    }
    
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
        	case KeyEvent.KEYCODE_BACK:
        		finish();
        		System.exit(0);
            	break;
        }
        return super.onKeyDown(keyCode, event);
    }
    
    private void updateWithNewLocation(Location location) {
        if (location != null) {
        	gpsdata result = new gpsdata();
        	result.num = num;
        	result.Latitude = (int) (location.getLatitude() * 1E6);
			result.Longitude = (int) (location.getLongitude() * 1E6);
			result.High = location.getAltitude();
			result.Direct = location.getBearing();
			result.Speed = location.getSpeed();
			Date d = new Date();
			d.setTime(location.getTime() + 28800000);
			result.GpsTime = DateFormat.format("yyyy-MM-dd kk:mm:ss", d).toString();
			
            myLocationText.setText(getString(R.string.fixed).toString());
            
            Latitude.setText(getString(R.string.latitude).toString() + String.format("%d", result.Latitude));
			Longitude.setText(getString(R.string.longitude).toString() + String.format("%d", result.Longitude));
			High.setText(getString(R.string.high).toString() + String.format("%f", result.High));
			Direction.setText(getString(R.string.direct).toString() + String.format("%f", result.Direct));
			Speed.setText(getString(R.string.speed).toString() + String.format("%f", result.Speed));
			GpsTime.setText(getString(R.string.time).toString() + String.format("%s", result.GpsTime));
			
        } else {
            myLocationText.setText(getString(R.string.notfixed).toString());
            Latitude.setText("");
			Longitude.setText("");
			High.setText("");
			Direction.setText("");
			Speed.setText("");
			GpsTime.setText("");
        }
        
    }
    
    private final LocationListener locationListener = new LocationListener() {
    	  public void onLocationChanged(Location location) {
    		  updateWithNewLocation(location);
    	  }
    	  
    	  public void onProviderDisabled(String provider){
    		  updateWithNewLocation(null);
    	  }
    	  
    	  public void onProviderEnabled(String provider){ 
    	  }
    	  
    	  public void onStatusChanged(String str, int status, Bundle extras){
    	  }
    	  
    	  };
    	  
	private GpsStatus.Listener gpsStatusListener = new GpsStatus.Listener() {  
          public void onGpsStatusChanged(int event) {  
          GpsStatus gpsStatus = locationManager.getGpsStatus(null);  
          switch (event) {  
            case GpsStatus.GPS_EVENT_FIRST_FIX: {  
            	fixed = true;
            	break;  
            	}  
  
            case GpsStatus.GPS_EVENT_SATELLITE_STATUS: {
                GpsStatus currentgpsStatus =locationManager.getGpsStatus(null);
                List<GpsSatellite> satelliteList = new ArrayList<GpsSatellite>();
                int maxSatellites = currentgpsStatus.getMaxSatellites();
                Iterator<GpsSatellite> iters = currentgpsStatus.getSatellites().iterator();
                int count = 0;     
                while (iters.hasNext() && count <= maxSatellites) {
                	satelliteList.add(iters.next());     
                	count++;
                }   
                num = count;
                satellitenumber.setText(String.valueOf(count));  
                String str = "";
                for(int i = 0; i < count; i++){
                	str = str + String.valueOf(satelliteList.get(i).getSnr()) + "\n"; 
                }
                allstrength.setText(str);
                break;
            	}  
  
            case GpsStatus.GPS_EVENT_STARTED: {  
                break;  
            	}  
  
            case GpsStatus.GPS_EVENT_STOPPED: {  
                break;  
            	}  
  
            default:  
                break;  
            	}  
        }  
    };  
}